const errorToDatapoint = require('./error_to_datapoint');
const { Endpoint } = require('bitsensor-node-js-core').Constants;

/**
 * Error helper class
 * @param {any} err 
 * @param {any} req 
 * @param {any} res 
 * @param {any} next 
 */
module.exports = (err, req, res, next) => {
  bitSensor.apply((datapoint) => {
    datapoint.endpoint[Endpoint.STATUS] = res.statusCode.toString();
  });

  if (err) {
    errorToDatapoint(err);
  }

  if (next) {
    next(err);
  }
};
