const { flatten } = require('./json_flatten');
const { Endpoint } = require('bitsensor-node-js-core').Constants;

/**
 * @param {Object} req
 * @param {Object} res
 * @param {Function} next
 */
module.exports = (req, res, next) => {
  bitSensor.session.bindEmitter(req);
  bitSensor.session.bindEmitter(res);

  bitSensor.runSession(() => {
    bitSensor.traceIncrement();
    // bitSensor.setHandlingRequest(true);
    const datapoint = bitSensor.getDatapoint();
    httpHandlerManager.postHandle(req, res, datapoint);

    // TODO: moved to http handler
    const method = req.method.toLowerCase();

    const flatBody = flatten(req.body);
    for (const key in flatBody) {
      datapoint.input[`http.${method}.${key}`] = flatBody[key];
    }
    const flatQuery = flatten(req.query);
    for (const key in flatQuery) {
      datapoint.input[`http.${method}.${key}`] = flatQuery[key];
    }

    res.on('finish', () => {
      bitSensor.apply((datapoint) => {
        datapoint.endpoint[Endpoint.STATUS] = res.statusCode.toString();
      });
      bitSensor.ship();
    });

    if (next) {
      next();
    }
  });
};
