const { Error, GeneratedBy } = require('bitsensor-node-js-core');
const stackTrace = require('stack-trace');

/**
 * @param {Error} err
 */
module.exports = (err) => {
  bitSensor.runSession(() => {
    const datapoint = bitSensor.getDatapoint();
    const trace = stackTrace.parse(err)[0];
    const error = new Error();
    error.code = 0;
    error.description = err.message;
    error.type = 'error';
    error.generatedby = GeneratedBy.PLUGIN;

    if (trace) {
      error.location = trace.getFileName();
      error.line = trace.getLineNumber();
    }

    datapoint.errors.push(error);
  });
};
