const flatten = (data) => {
  const result = {};
  recurse(data, '', result);
  return result;
};

function recurse(cur, prop, result) {
  if (Object(cur) !== cur) {
    addCurrentToResult(result, prop, cur);
  } else if (Array.isArray(cur)) {
    recurseInArray(cur, prop, result);
    if (cur.length === 0) {
      addCurrentToResult(result, prop, null);
    }
  } else {
    let isEmpty = true;
    isEmpty = recurseInObject(cur, prop, isEmpty, result);
    checkEmptyAndPropNotNull(isEmpty, result, prop);
  }
}

function addCurrentToResult(result, prop, cur) {
  if (cur == null) {
    cur = [];
  }
  result[prop] = cur;
}

function recurseInArray(cur, prop, result) {
  for (let i = 0; i < cur.length; i++) {
    recurse(cur[i], `${prop}[${i}]`, result);
  }
}

function recurseInObject(cur, prop, isEmpty, result) {
  for (const p in cur) {
    isEmpty = false;
    recurse(cur[p], prop ? `${prop}.${p}` : p, result);
  }
  return isEmpty;
}

function checkEmptyAndPropNotNull(isEmpty, result, prop) {
  if (isEmpty && prop) {
    result[prop] = {};
  }
}

module.exports = {
  flatten,
  addCurrentToResult,
  recurseInArray,
  recurseInObject,
  checkEmptyAndPropNotNull,
};
