const core = require('bitsensor-node-js-core');
require('./init');
const Handler = require('bitsensor-node-js-core/handler/handler');
const express = require('express');
const cookieParser = require('cookie-parser');
const bodyParser = require('body-parser');
const session = require('express-session');

const app = express();
app.use(bodyParser.json());
app.use(bodyParser.urlencoded({ extended: false }));
app.use(cookieParser());
app.use(session({
  secret: 'm4F3ePd452Ds45GdvnwDfe35gF',
  saveUninitialized: true,
  resave: true,
}));

const datapointCollector = [];

class IntegrationTestHandler extends Handler {
  handle(datapoint) {
    datapointCollector.push(datapoint);
  }
}

const integrationTestHandler = new IntegrationTestHandler();
bitSensor.addPostHandler(integrationTestHandler);

bitSensor.runSession(() => {
  bitSensor.runPostHandlers();
});

app.get('/errortest', (req, res, next) => {
  throw new Error('error thrown');
});

app.get('/gettest', (req, res) => {
  res.send('get');
});

app.post('/posttest', (req, res) => {
  res.send('post');
});

app.set('port', 3001);
const server = app.listen(app.get('port'), () => {
  console.log(`Server started on port ${app.get('port')}`);
});

module.exports = {
  app,
  server,
  datapointCollector,
  core,
};
