const errorToDatapoint = require('../core/error_to_datapoint');
require('bitsensor-node-js-core');

const chai = require('chai');
const chaiHttp = require('chai-http');

const { expect } = chai;
chai.use(chaiHttp);

describe('Error_to_datapoint', () => {
  describe('#error_to_datapoint', () => {
    it('should contain stacktrace', () => {
      const error = new Error('test error');
      bitSensor.runSession(() => {
        errorToDatapoint(error);
        expect(bitSensor.getDatapoint().errors).has.lengthOf(1);
        expect(bitSensor.getDatapoint().errors[0]).has.keys([
          'code',
          'context',
          'description',
          'line',
          'location',
          'type',
          'generatedby',
        ]);
      });
    });
  });
});
